/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using MVR.FileManagementSecure;namespace PluginIdea{    public class EncodeHelper    {                                                        public static void EncodeToVideo(MVRScript ower)        {            string targetFolder = "H:/Benti/Saves/CameraRecord/";            string tmpFolder = targetFolder + "temp";            int frameRate = 25;            int minNum = 279;            int maxNum = 607;            int width = 480;            int height = 480;            SuperController.LogMessage("Start Convert: ");            for (int i = minNum; i <= maxNum; i++)            {                string filename = targetFolder + i.ToString();                if (FileManagerSecure.FileExists(filename))                {                    byte[] bfs = FileManagerSecure.ReadAllBytes(filename);                    Texture2D t2d = new Texture2D(width, height, TextureFormat.RGB24, false);                    t2d.LoadRawTextureData(bfs);                    byte[] bfsfinal = t2d.EncodeToJPG();                    string saveFilename = string.Format("{0}/{1}.jpg", tmpFolder, i);                    SuperController.LogMessage(saveFilename);                    FileManagerSecure.CreateDirectory(tmpFolder);                    FileManagerSecure.WriteAllBytes(saveFilename, bfsfinal);                }                else                {                    SuperController.LogMessage(string.Format("{0} Not exist, skipped",i));                }            }            SuperController.LogMessage("Start FFmpeg Convert");                        string ffmpegPath = Utils.GetPluginPath(ower) + "/encoder/ffmpeg-64.exe";            SuperController.LogMessage("ffmpegPath: " + ffmpegPath);            string outputPath = targetFolder + Time.time.ToString() + ".mp4";            string cmdStr = string.Format(@"""{0}"" -f ""{1}"" -i %d.jpg {2} ", ffmpegPath, tmpFolder, outputPath);            SuperController.LogMessage("cmdStr: " + cmdStr);            Utils.RunCmd2("cmd.exe", cmdStr);        }    }}