/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System.Collections;using System.Collections.Generic;using UnityEngine;using System;namespace PluginIdea{    public class SimpleTrigger : MonoBehaviour    {        private Color pressColor = Color.green;        private Color normalColor = Color.white;        public Action onTrigger;        private Renderer rd;        private float timer;        private float ignoreTime = 1f;        private bool isTrigged = false;        public Renderer Renderer        {            get {                if (rd == null) rd = GetComponent<Renderer>();                return rd;            }        }        private void Start()        {            Renderer.material.color = normalColor;        }        private void Update()        {            if (Input.GetMouseButtonUp(2))            {                Ray ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);                RaycastHit hit;                if (Physics.Raycast(ray, out hit, Mathf.Infinity))                {                    if (hit.collider.name == gameObject.name)                    {                        if (onTrigger != null) onTrigger();                    }                }            }                        if (isTrigged)            {                timer += Time.deltaTime;                if (timer > ignoreTime)                {                    isTrigged = false;                    timer = 0;                }            }        }        private void OnTriggerEnter(Collider other)        {            if (!isTrigged)            {                isTrigged = true;                if (onTrigger != null) onTrigger();                Renderer.material.color = pressColor;            }        }        private void OnTriggerExit(Collider other)        {                                    Renderer.material.color = normalColor;        }    }}